#!/usr/bin/perl

###############################################################################
# Greymatter 1.7.3                            
# Copyright (c)2000-2007, The Greymatter team 
# http://greymatterforum.proboards82.com/     
# By possessing this software, you agree not to hold the author responsible for 
# any problems that may arise from your installation or usage of Greymatter 
# itself, or from any content generated by yourself or others through the use of 
# this program.  You <I>may</I> freely modify and redistribute this program, so 
# long as every copyright notice (including in this manual and in the Greymatter 
# code) remains fully intact.  Finally, you may <I>not</I> sell or in any way 
# make a financial profit from this program, either in original or modified form.
# Your possession of this software signifies that you agree to these terms; 
# please delete your copy of this software if you don't agree to these terms.
# Original Creators Noah Grey
###############################################################################

use lib 'libs';

use CGI::Carp qw(fatalsToBrowser);
use Gm_Constants;
use Gm_Web;
use Gm_Core;

require "gm-library.cgi";

### TODO: refactor into gm_uactions (Gm User Actions) to remove dependancy on gm-library.cgi

%IN = %{Gm_Web::getWebParams( errHandler=>\&Gm_Web::displayUserErrorExit )};

$userip = $ENV{'REMOTE_ADDR'};

&gm_readconfig;
&gm_readtemplates;
&gm_readcounter;

&gm_karmabancheck;

# open (FUNNYFEET, "$EntriesPath/$IN{'entry'}.cgi") || 
# 	Gm_Web::displayUserErrorExit("Can't open $EntriesPath/$IN{'entry'}.cgi.  ".
# 		"Please make sure your paths are configured correctly and that your ".
# 		"entries/archives directory is CHMODed to 777.");
# @entrylines = <FUNNYFEET>;
# close (FUNNYFEET);
# 
# $gmcounter = 0;
# 
# foreach (@entrylines) {
# 	chomp ($entrylines[$gmcounter]);
# 	$gmcounter++;
# }
# 
# ($thisentrynumber, $thisentryauthor, $thisentrysubject, $thisentryweekdaynumber, $thisentrymonth, $thisentryday, $thisentryyearyear, $thisentryhour, $thisentryminute, $thisentrysecond, $thisentryampm, $thisentrypositivekarma, $thisentrynegativekarma, $thisentrycommentsnumber, $thisentryallowkarma, $thisentryallowcomments, $thisentryopenstatus, $thisentrymusic, $thisentrymood, $thisentryemoticonsallowed) = split (/\|/, $entrylines[0]);
## TODO: VALIDATE ENTRY, IT COULD BE DICEY
if( $IN{'entry'} =~ m/\D/gos ){
		## We got a non digit entered, more than likely, this is a hack attempt
		# TODO: INTEGRATE INTO GM_PHPHACKCHECK (AND RENAME), SO WE CAN EMAIL!
		Gm_Web::displayUserErrorExit('A invalid value was given for "entry" when karma voting.');
}
$newcommententrynumberpadded = Gm_Utils::toEntryPadded( $IN{'entry'} );

my $gmEntry = Gm_Storage::getEntry( id=>$IN{'entry'},
	errHandler=>\&Gm_Web::displayUserErrorExit );

## TODO: refactor out usage of variables, make work directly off of entry
$thisentrynumber = $gmEntry->{'entryinfo'}{'id'};
$thisentryauthor = $gmEntry->{'entryinfo'}{'author'};
$thisentrysubject = $gmEntry->{'entryinfo'}{'subject'};
$thisentryweekdaynumber = $gmEntry->{'entryinfo'}{'weekday'};
$thisentrymonth = $gmEntry->{'entryinfo'}{'month'};
$thisentryday = $gmEntry->{'entryinfo'}{'day'};
$thisentryyearyear = $gmEntry->{'entryinfo'}{'year'};
$thisentryhour = $gmEntry->{'entryinfo'}{'hour'};
$thisentryminute = $gmEntry->{'entryinfo'}{'minute'};
$thisentrysecond = $gmEntry->{'entryinfo'}{'second'};
$thisentryampm = $gmEntry->{'entryinfo'}{'ampm'};
$thisentrypositivekarma = $gmEntry->{'entryinfo'}{'karmapos'};
$thisentrynegativekarma = $gmEntry->{'entryinfo'}{'karmaneg'};
$thisentrycommentsnumber = $gmEntry->{'entryinfo'}{'commenttotal'};
$thisentryallowkarma = $gmEntry->{'entryinfo'}{'karma'};
$thisentryallowcomments = $gmEntry->{'entryinfo'}{'comments'};
$thisentryopenstatus = $gmEntry->{'entryinfo'}{'status'};
$thisentrymusic = $gmEntry->{'entryinfo'}{'music'};
$thisentrymood = $gmEntry->{'entryinfo'}{'mood'};
$thisentryemoticonsallowed = $gmEntry->{'entryinfo'}{'emoticons'};


&gm_allowedcheck;
&gm_blankcheck;
&gm_votetwicecheck;
&gm_addkarma;
&gm_freshenafterkarma;

# -------------
# check for ban
# -------------
## TODO MAKE THIS FUNCTION A UTIL OR SOMETHING, ITS IN COMMENTS TOO
sub gm_karmabancheck {

	my $gmbanlist = Gm_Storage::getBanlist( errHandler=>\&Gm_Web::displayUserErrorExit );
	if( scalar( keys(%$gmbanlist)) > 0 ){
		foreach $gmbanlistline ( keys( %$gmbanlist ) ) {
		
			my ($checkthisip, $checkthisiphost, $checkthisperson) = 
				($gmbanlist->{$gmbanlistline}{'ip'}, $gmbanlist->{$gmbanlistline}{'host'}, 
				 $gmbanlist->{$gmbanlistline}{'label'} );
			if ($userip =~ m/$checkthisip/i) {
	
				if (($keeplog eq Gm_Constants::YES) && ($logkarmaandcomments eq Gm_Constants::YES)) {
					my $cp_message = "<FONT COLOR=\"#FF0000\"><B>A banned IP ($checkthisip/$checkthisiphost";
					if ($checkthisperson ne "") { 
						$cp_message .= ", \"$checkthisperson\""; 
					}
					$cp_message .= ") attempted to cast a $IN{'vote'} karma vote on entry ".
						"#$thisentrynumber</B></FONT>";
					Gm_Core::writeToCplog( $cp_message, \&Gm_Web::displayUserErrorExit );			
				}
				
				Gm_Web::displayUserErrorExit("You have been banned from voting on this site.<BR>(IP: $userip)");
			}
		}
	}
}

# --------------------------------
# check if karma votes can be cast
# --------------------------------

sub gm_allowedcheck {

	if (($posttoarchives eq Gm_Constants::NO) && ($thisentrynumber <= $newarchivenumber)) {
		if (($keeplog eq Gm_Constants::YES) && ($logkarmaandcomments eq Gm_Constants::YES)) {
			my $cp_message = "A $IN{'vote'} karma vote was blocked from being added to archived entry #$thisentrynumber";
			Gm_Core::writeToCplog( $cp_message, \&Gm_Web::displayUserErrorExit );
		}
		Gm_Web::displayUserErrorExit('Sorry - karma votes cannot be cast on archived entries. '.
			'Please use your browser\'s Back button to return.');
	}

if (($thisentryallowkarma eq Gm_Constants::NO) || 
		($thisentryopenstatus eq Gm_Constants::CLOSED) || ($allowkarmaorcomments eq Gm_Constants::COMMENTS) || 
		($allowkarmaorcomments eq Gm_Constants::NEITHER)) {

if (($keeplog eq Gm_Constants::YES) && ($logkarmaandcomments eq Gm_Constants::YES)) {
	my $cp_message = "A $IN{'vote'} karma vote was blocked from being cast on entry #$IN{'newcommententrynumber'}";
	Gm_Core::writeToCplog( $cp_message, \&Gm_Web::displayUserErrorExit );
}

Gm_Web::displayUserErrorExit('Sorry - karma votes cannot be cast on this entry. '.
	'Please use your browser\'s Back button to return.');

}

}

# --------------------------------------
# check if this person has already voted
# --------------------------------------

sub gm_votetwicecheck {

# 	@pastkarmavotes = split (/\|/, $entrylines[1]);
 	@pastkarmavotes = keys( %{$gmEntry->{'karmavotes'}} );	
	$votedtwice = Gm_Constants::NO;
	
	foreach $googoogajoob (@pastkarmavotes) {
		if ($googoogajoob eq $userip) {
			if ($allowmultiplekarmavotes eq Gm_Constants::YES) {
			$votedtwice = Gm_Constants::YES;
			} else {
			
			if (($keeplog eq Gm_Constants::YES) && ($logkarmaandcomments eq Gm_Constants::YES)) {
				my $cp_message = "A repeat karma vote ($IN{'vote'}) was blocked from being added to entry #$thisentrynumber";
				Gm_Core::writeToCplog( $cp_message, \&Gm_Web::displayUserErrorExit );
			}
			
			Gm_Web::displayUserErrorExit('Sorry - you can\'t vote twice on the same entry.  '.
				'Please use your browser\'s Back button to return.');
			}		
		}
	}
}

# ---------------------------
# check if the input is blank
# ---------------------------
sub gm_blankcheck {

	if (($IN{'vote'} eq Gm_Constants::EMPTY) || ($IN{'entry'} eq Gm_Constants::EMPTY)) {	
		Gm_Web::displayUserErrorExit('Error: Blank fields reported in the karma module '.
			'input.  Please report to this site\'s webmaster.');
	}
}

# ------------------
# add the karma vote
# ------------------

sub gm_addkarma {

if ($IN{'vote'} eq 'positive') {
	$thisentrypositivekarma++;
	$newalltimepktotalnumber++;
#	unless ($votedtwice eq Gm_Constants::YES) { $entrylines[1] .= "|$userip|P"; }
	unless ($votedtwice eq Gm_Constants::YES) { 
		$gmEntry->{'karmavotes'}{"$userip"} = 'P'; 
	}
}
if ($IN{'vote'} eq 'negative') {
	$thisentrynegativekarma++;
	$newalltimenktotalnumber++;
#	unless ($votedtwice eq Gm_Constants::YES) { $entrylines[1] .= "|$userip|N"; }
	unless ($votedtwice eq Gm_Constants::YES) { 
		$gmEntry->{'karmavotes'}{"$userip"} = 'N'; 
	}
}

# Silent Bob - 02/02/2004
# Added $thisentrymusic and $thisentrymood variables to prevent them
# from being lost on a karma entry
# $entrylines[0] = "$thisentrynumber|$thisentryauthor|$thisentrysubject|$thisentryweekdaynumber|$thisentrymonth|$thisentryday|$thisentryyearyear|$thisentryhour|$thisentryminute|$thisentrysecond|$thisentryampm|$thisentrypositivekarma|$thisentrynegativekarma|$thisentrycommentsnumber|$thisentryallowkarma|$thisentryallowcomments|$thisentryopenstatus|$thisentrymusic|$thisentrymood|$thisentryemoticonsallowed";
$gmEntry->{'entryinfo'}{'karmapos'} = $thisentrypositivekarma;
$gmEntry->{'entryinfo'}{'karmaneg'} = $thisentrynegativekarma;

# $gmcounter = 0;

# open (FUNNYFEET, ">$EntriesPath/$newcommententrynumberpadded.cgi") || 
# 	Gm_Web::displayUserErrorExit("Can't write to $EntriesPath/$newcommententrynumberpadded.cgi.  ".
# 		"Please make sure that your paths are configured correctly and that your ".
# 		"entries/archives directory is CHMODed to 777.");
# foreach $entrynewline (@entrylines) { print FUNNYFEET "$entrynewline\n"; }
# close (FUNNYFEET);
Gm_Storage::setEntry( entry=>$gmEntry, errHandler=>\&Gm_Web::displayAdminErrorExit );

}

# ------------------------
# primp, preen, take a bow
# ------------------------

sub gm_freshenafterkarma {

&gm_writecounter;
&gm_readtemplates;

# &gm_getentryvariables($IN{'entry'});
$entryVars = Gm_Core::getEntryVariables( entryid=>$IN{'entry'}, 
	errHandler=>\&Gm_Web::displayAdminErrorExit ); 

## fix the referrer logic, or lack thereof, for $aftermath
## 
$aftermath = $ENV{'HTTP_REFERER'};
## added in 1.3.1 linear

if ($generateentrypages eq Gm_Constants::YES) {
	if ($entryVars->{'thisentrymorebody'} ne Gm_Constants::EMPTY ) {
#		&gm_formatentry($gmmoreentrypagetemplate);
		$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
			template=>$gmmoreentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);		
	} else {
#		&gm_formatentry($gmentrypagetemplate);
		$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
			template=>$gmentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);		
	}
# 	open (THISFILE, ">$EntriesPath/$IN{'entry'}.$entrysuffix") || 
# 		Gm_Web::displayUserErrorExit("Can't write to $EntriesPath/$IN{'entry'}.".
# 			"$entrysuffix.  Please make sure that your paths are configured correctly ".
# 			"and that your entries/archives directory is CHMODed to 777.");
# 	print THISFILE $entryreturn;
# 	close (THISFILE);
## TODO: USE NON-PADDED NUMBER AND USE PAD ENTRY HERE

		Gm_Storage::saveFile( loc=>"$EntriesPath/$newcommententrynumberpadded.$entrysuffix", 
			content=>[$entryreturn],'new'=>1, ch_mod=>'0666', 
			errHandler=>\&Gm_Web::displayAdminErrorExit );
}

if ( $entryVars->{'thisentryisanarchive'} eq Gm_Constants::NO) {
	&gm_generatemainindex;
} else {
	&gm_readcounter;
	$stoppednumber = $newarchivenumber;
	do { &gm_generatearchive($stoppednumber); } until $stoppednumber <= 1;
	if( $gmneedstogeneratefirstarchive ){ &gm_generatearchive(1); }
}

&gm_readconfig;

if (($NotifyForStatus eq Gm_Constants::KARMA) || ($NotifyForStatus eq Gm_Constants::BOTH)) {
if ($NotifyEmail ne "") {

# &gm_getentryvariables($IN{'entry'});
$entryVars = Gm_Core::getEntryVariables( entryid=>$IN{'entry'}, 
	errHandler=>\&Gm_Web::displayAdminErrorExit ); 

my $emailMsg = "A $IN{'vote'} karma vote has just been cast by $userip IP on entry ".
	"#$thisentrynumber ($thisentrysubject).  That brings this entry to $thisentrypositivekarma ".
	"positive and $thisentrynegativekarma negative karma votes for a ".
	"$entryVars->{'thisentrytotalkarma'} total karma rating.";

Gm_Core::sendEmail( to=>$NotifyEmail, subject=>'Notice: Karma Vote Cast', 
	body=>$emailMsg );

# $sendithere = "$mailprog -t";
# 
# @sendestinations = split (/;/, $NotifyEmail);
# 
# foreach $destinationow (@sendestinations) {
# 
# # TODO: MOVE TO UTIL sendMail (will check preferences to see if send), Core?
# # TODO: VALIDATE THE MESSAGE
# open (MAIL, "|$sendithere") || 
# 	Gm_Web::displayUserErrorExit("Can't open the mail program at $mailprog.  ".
# 		"Please make sure you have this configured correctly.");
# print MAIL <<__MAILNOTIFY__;
# To: $destinationow
# From: $destinationow
# Subject: [Greymatter] Notice: Karma Vote Cast
# 
# A $IN{'vote'} karma vote has just been cast by $userip IP on entry #$thisentrynumber ($thisentrysubject).  That brings this entry to $thisentrypositivekarma positive and $thisentrynegativekarma negative karma votes for a $entryVars->{'thisentrytotalkarma'} total karma rating.
# 
# -----
# Greymatter $gmversion
# http://noahgrey.com/greysoft/
# 
# __MAILNOTIFY__
# 
# close(MAIL);
# 
# }

}
}

if (($keeplog eq Gm_Constants::YES) && ($logkarmaandcomments eq Gm_Constants::YES)) {
	Gm_Core::writeToCplog( "<I>A $IN{'vote'} karma vote was cast on entry #$thisentrynumber ".
		"($thisentrysubject)</I>", \&Gm_Web::displayUserErrorExit );

}

## Time to send user back to page came from
Gm_Web::displayUserRedirectExit( $aftermath );

exit;

}

